#!/bin/sh

#-------------------- COPYRIGHT STATEMENT ------------------------------
#
# Licensed Materials - Property of IBM
# 5724-C40
# (C) Copyright IBM Corp. 2002.  All Rights Reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.
#
#------------------- END OF COPYRIGHT STATEMENT ------------------------
#
#
#  $Revision: @(#)22 1.11 src/com/tivoli/managed/install/files/install.sh, slminstall, slm1.2.1.fp1 02/06/13 17:10:25 $
#
# Script to launch SLM install program

OS_NAME=`uname`

# Set variables based on OS name
case "${OS_NAME}" in
  AIX)
   JAVA_CMD="java/aix4-r1/jre/bin/java"
   USERNAME=`/usr/bin/whoami`
   KERNVER=`bootinfo -K`
   if [ "${KERNVER}" = "32" ]; then
	LDR_CNTRL=MAXDATA=0x30000000
	export LDR_CNTRL
   fi	
   ;;
  SunOS|Solaris)
   JAVA_CMD="java/solaris2/bin/java"
   USERNAME=`/usr/ucb/whoami`
   ;;
  Linux)
   JAVA_CMD="java/linux/jre/bin/java"
   export JAVA2D_USEAWTFONTS=0
   USERNAME=`/usr/bin/whoami`
   ;;
  *)
   echo "Unspported platform: $OS_NAME"
   echo "Exiting ..."
   exit 1
   ;;
esac


if [ "${USERNAME}" != "root" ]; then
  echo "You must be root to run this command."
  exit 1
fi

CLASSPATH=.:ismp/setup.jar:$CLASSPATH  export CLASSPATH

# WLW allows command line arguments & silent install
SWITCHES=
OPTIONS=
FILE=
FILE_NEXT=false

for x in $1 $2 $3 $4 $5 $6 $7 $8 $9; do
    # If we're looking for the silent install response file name next...
    if [ "$FILE_NEXT" = "true" ] ; then
        FILE=$x
        FILE_NEXT=false;
    else
        # If the current argument is the "-options" flag....
        if [ "$x" = "-options" ] ; then
            OPTIONS=$x
            FILE_NEXT=true;
        else
            SWITCHES="${SWITCHES} ${x}";
        fi
    fi
done
# end WLW

$JAVA_CMD $SWITCHES -cp $CLASSPATH run $OPTIONS $FILE
