------------------------ COPYRIGHT STATEMENT ----------------------------
--
-- Licensed Materials - Property of IBM
-- 5724-C40
-- (C) Copyright IBM Corp. 2003.  All Rights Reserved.
--
-- US Government Users Restricted Rights - Use, duplication or
-- disclosure restricted by GSA ADP Schedule Contract with
-- IBM Corp.
--
------------------------END OF COPYRIGHT STATEMENT -----------------------

--------------------------------------------------------------------------
--  CMVC Location:  src/tedw_apps/dyk/etl/sql/DYK_m05_s020_Populate_Reg_Datamart.db2, etl.target, slm1.2.1.fp1
--  Version:        1.2
--  Last Modified:  8/14/03
--------------------------------------------------------------------------

--#EXECUTE_AT_TARGET
delete from MM.MSRC;

--#INSERT_INTO_TARGET
insert into MM.MSRC 
SELECT DISTINCT
    TWG.MSRC.MSRC_CD AS MSRC_CD,
    CONCAT('MSrc.MSrc_Nm.',RTRIM(TWG.MSRC.MSRC_CD)) AS MSRC_NM,
    TWG.MSRC.MSRC_NM AS MSRC_NM_DEF
FROM 
    TWG.MSRC,
    DYK.STAGE_MSMTTYP 
WHERE 
   (       (         TWG.MSRC.MSRC_CD = DYK.STAGE_MSMTTYP.MSRC_CD       )    );

-- #################################### -- 

--#EXECUTE_AT_TARGET
delete from MM.MUNITCAT;

--#INSERT_INTO_TARGET
insert into MM.MUNITCAT 
SELECT DISTINCT
    TWG.MUNITCAT.MUNITCAT_CD AS MUNITCAT_CD,
    CONCAT('MUnitCat.MUnitCat_Nm.',RTRIM(TWG.MUNITCAT.MUNITCAT_CD)) AS MUNITCAT_NM, 
    TWG.MUNITCAT.MUNITCAT_NM AS MUNITCAT_NM_DEF 
FROM 
    TWG.MUNIT,
    DYK.STAGE_MSMTTYP,
    TWG.MUNITCAT 
WHERE 
   (       (         TWG.MUNITCAT.MUNITCAT_CD = TWG.MUNIT.MUNITCAT_CD 
AND 
        TWG.MUNIT.MUNIT_CD = DYK.STAGE_MSMTTYP.MUNIT_CD       )    );

-- #################################### -- 

--#EXECUTE_AT_TARGET
delete from MM.MUNIT;

--#INSERT_INTO_TARGET
insert into MM.MUNIT 
SELECT DISTINCT
    TWG.MUNIT.MUNIT_CD AS MUNIT_CD,
    TWG.MUNIT.MUNITCAT_CD AS MUNITCAT_CD,
    CONCAT('MUnit.MUnit_Nm.',RTRIM(TWG.MUNIT.MUNIT_CD)) AS MUNIT_NM,
    TWG.MUNIT.MUNIT_NM AS MUNIT_NM_DEF  
FROM 
    TWG.MUNIT,
    DYK.STAGE_MSMTTYP 
WHERE 
   (       (         DYK.STAGE_MSMTTYP.MUNIT_CD = TWG.MUNIT.MUNIT_CD       )    );

-- #################################### -- 

--#EXECUTE_AT_TARGET
delete from MM.MSMTTYP;

--#INSERT_INTO_TARGET
insert into MM.MSMTTYP 
SELECT 
    DYK.STAGE_MSMTTYP.MSMTTYP_ID AS MSMTTYP_ID,
    DYK.STAGE_MSMTTYP.MUNIT_CD AS MUNIT_CD,
    DYK.STAGE_MSMTTYP.MSRC_CD AS MSRC_CD,
    CONCAT('MsmtTyp.MsmtTyp_Nm.',DYK.STAGE_MSMTTYP.MSMTTYP_NM) AS MSMTTYP_NM,
    CONCAT('MsmtTyp.MsmtTyp_Ds.',DYK.STAGE_MSMTTYP.MSMTTYP_NM) AS MSMTTYP_DS, 
    DYK.STAGE_MSMTTYP.MSMTTYP_NM AS MSMTTYP_NM_DEF,
    DYK.STAGE_MSMTTYP.MSMTTYP_DS AS MSMTTYP_DS_DEF 
FROM 
    DYK.STAGE_MSMTTYP;

-- #################################### -- 

--#EXECUTE_AT_TARGET
delete from MM.MGRPTYP;

--#INSERT_INTO_TARGET
insert into MM.MGRPTYP 
SELECT DISTINCT
    TWG.MGRPTYP.MGRPTYP_CD AS MGRPTYP_CD,
    CONCAT('MGrpTyp.MGrpTyp_Nm.',RTRIM(TWG.MGRPTYP.MGRPTYP_CD)) AS MGRPTYP_NM, 
    TWG.MGRPTYP.MGRPTYP_NM AS MGRPTYP_NM_DEF 
FROM 
    DYK.STAGE_MSMTTYP,
    TWG.MGRPMBR,
    TWG.MGRPTYP 
WHERE 
   (       (         TWG.MGRPMBR.MSMTTYP_ID = DYK.STAGE_MSMTTYP.MSMTTYP_ID 
AND 
        TWG.MGRPTYP.MGRPTYP_CD = TWG.MGRPMBR.MGRPTYP_CD       )    );

-- #################################### -- 

--#EXECUTE_AT_TARGET
delete from MM.MGRP;

--#INSERT_INTO_TARGET
insert into MM.MGRP 
SELECT DISTINCT
    TWG.MGRP.MGRP_CD AS MGRP_CD,
    TWG.MGRP.MGRPTYP_CD AS MGRPTYP_CD,
    CONCAT('MGrp.MGrp_Nm.',RTRIM(TWG.MGRP.MGRP_CD)) AS MGRP_NM,
    TWG.MGRP.MGRP_NM AS MGRP_NM_DEF
FROM 
    DYK.STAGE_MSMTTYP,
    TWG.MGRP,
    TWG.MGRPMBR 
WHERE 
   (       (         TWG.MGRPMBR.MSMTTYP_ID = DYK.STAGE_MSMTTYP.MSMTTYP_ID 
AND 
        TWG.MGRP.MGRP_CD = TWG.MGRPMBR.MGRP_CD 
AND 
        TWG.MGRPMBR.MGRPTYP_CD = TWG.MGRP.MGRPTYP_CD       )    );

-- #################################### -- 

--#EXECUTE_AT_TARGET
delete from MM.MGRPMBR;

--#INSERT_INTO_TARGET
insert into MM.MGRPMBR 
SELECT DISTINCT    
    TWG.MGRPMBR.MGRP_CD AS MGRP_CD, 
    TWG.MGRPMBR.MGRPTYP_CD AS MGRPTYP_CD,
    TWG.MGRPMBR.MSMTTYP_ID AS MSMTTYP_ID
FROM 
    DYK.STAGE_MSMTTYP,
    TWG.MGRPMBR 
WHERE 
   (       (         TWG.MGRPMBR.MSMTTYP_ID = DYK.STAGE_MSMTTYP.MSMTTYP_ID       )    );

-- #################################### -- 

--#IGNORE_ERROR
--#EXECUTE_AT_TARGET
drop table MM.STAGE_COMPTYP;

--#EXECUTE_AT_TARGET
CREATE TABLE MM.STAGE_COMPTYP (
       COMPTYP_CD           CHAR(17) NOT NULL,
       COMPTYP_PARENT_CD    CHAR(17),
       COMPTYP_NM           VARCHAR(64) NOT NULL,
       COMPTYP_STRT_DTTM    TIMESTAMP NOT NULL,
       COMPTYP_END_DTTM     TIMESTAMP NOT NULL,
       COMPTYP_NM_DEF       VARCHAR(120) NOT NULL
);

--#INSERT_INTO_TARGET
insert into MM.STAGE_COMPTYP 
SELECT 
    TWG.COMPTYP.COMPTYP_CD AS COMPTYP_CD,
    TWG.COMPTYP.COMPTYP_PARENT_CD AS COMPTYP_PARENT_CD,
    CONCAT('CompTyp.CompTyp_Nm.',RTRIM(TWG.COMPTYP.COMPTYP_CD)) AS COMPTYP_NM, 
    TWG.COMPTYP.COMPTYP_STRT_DTTM AS COMPTYP_STRT_DTTM,
    TWG.COMPTYP.COMPTYP_END_DTTM AS COMPTYP_END_DTTM,
    TWG.COMPTYP.COMPTYP_NM AS COMPTYP_NM_DEF 
FROM 
    TWG.COMPTYP;

--#EXECUTE_AT_TARGET
insert into MM.COMPTYP 
SELECT 
    COMPTYP_CD AS COMPTYP_CD,
    COMPTYP_PARENT_CD AS COMPTYP_PARENT_CD,
    COMPTYP_NM AS COMPTYP_NM, 
    COMPTYP_STRT_DTTM AS COMPTYP_STRT_DTTM,
    COMPTYP_END_DTTM AS COMPTYP_END_DTTM,
    COMPTYP_NM_DEF AS COMPTYP_NM_DEF 
FROM 
    MM.STAGE_COMPTYP
WHERE
    COMPTYP_CD NOT IN (SELECT COMPTYP_CD FROM MM.COMPTYP);

-- 
-- Detect component types that have expired in the CDW and
-- expire them in this mart (by updating COMPTYP_END_DTTM).
--

--#IGNORE_ERROR
--#EXECUTE_AT_TARGET
drop table MM.STAGE_EXPCOMPTYP;

--#EXECUTE_AT_TARGET
CREATE TABLE MM.STAGE_EXPCOMPTYP (
       COMPTYP_CD           CHAR(17) NOT NULL,
       COMPTYP_END_DTTM     TIMESTAMP NOT NULL
);

--#INSERT_INTO_TARGET
insert into MM.STAGE_EXPCOMPTYP
SELECT
    CT.COMPTYP_CD,
    CT.COMPTYP_END_DTTM
FROM
    TWG.COMPTYP CT
WHERE
    CT.COMPTYP_END_DTTM <= (CURRENT TIMESTAMP - CURRENT TIMEZONE);

--
-- Expire the component type records in the mart.
--
--#EXECUTE_AT_TARGET
update MM.COMPTYP CT SET COMPTYP_END_DTTM = (SELECT COMPTYP_END_DTTM FROM MM.STAGE_EXPCOMPTYP ECT WHERE
   CT.COMPTYP_CD = ECT.COMPTYP_CD) WHERE COMPTYP_CD IN (SELECT COMPTYP_CD FROM MM.STAGE_EXPCOMPTYP);

-- #################################### -- 

--#EXECUTE_AT_TARGET
delete from MM.MSMTRUL;

--#INSERT_INTO_TARGET
insert into MM.MSMTRUL 
SELECT 
    TWG.MSMTRUL.COMPTYP_CD AS COMPTYP_CD,
    TWG.MSMTRUL.MSMTTYP_ID AS MSMTTYP_ID 
FROM 
    DYK.STAGE_MSMTTYP,
    TWG.MSMTRUL 
WHERE 
   (       (         TWG.MSMTRUL.MSMTTYP_ID = DYK.STAGE_MSMTTYP.MSMTTYP_ID       )    );

-- #################################### -- 

--#INSERT_INTO_TARGET
insert into MM.COMP 
SELECT 
    TWG.CUR_COMP.COMP_ID AS COMP_ID,
    TWG.CUR_COMP.COMPTYP_CD AS COMPTYP_CD,
    RTRIM(TWG.CUR_COMP.COMP_NM) AS COMP_NM,
    TWG.CUR_COMP.COMP_CORR_VAL AS COMP_LONG_NM,
    TWG.CUR_COMP.COMP_STRT_DTTM AS COMP_STRT_DTTM,
    TWG.CUR_COMP.COMP_END_DTTM AS COMP_END_DTTM,
    TWG.CUR_COMP.COMP_DS AS COMP_DS 
FROM 
    TWG.CUR_COMP 
WHERE
    TWG.CUR_COMP.COMP_ID > (SELECT EC.EXTCTL_TO_INTSEQ FROM TWG.EXTRACT_CONTROL EC WHERE
       EC.EXTCTL_SOURCE = 'TWG.CUR_COMP' AND EC.EXTCTL_TARGET = 'DYK.COMP');

--
-- Delete expired components from the mart.
--

--
-- First, load the time of the last ETL completion
-- into a CDW staging table.
--

--#IGNORE_ERROR
drop table DYK.STAGE_ETL_INFO;

CREATE TABLE DYK.STAGE_ETL_INFO (
   ETL_END_DTTM   TIMESTAMP
);

--#INSERT_INTO_SOURCE
insert into DYK.STAGE_ETL_INFO 
SELECT 
    MAX(H.ETL_END_DTTM)
FROM
    MM.HISTORY H;

--
-- Then get the IDs of all components that have expired
-- since the completion of the last ETL run.
--
--#EXECUTE_AT_TARGET
--#IGNORE_ERROR
drop table MM.STAGE_EXPCOMP;

--#EXECUTE_AT_TARGET
CREATE TABLE MM.STAGE_EXPCOMP (
   COMP_ID         INTEGER      NOT NULL
);

--#INSERT_INTO_TARGET
insert into MM.STAGE_EXPCOMP 
SELECT
    C.COMP_ID
FROM
    TWG.COMP C
WHERE
    C.COMP_END_DTTM BETWEEN (SELECT ETL_END_DTTM FROM DYK.STAGE_ETL_INFO) AND (CURRENT TIMESTAMP - CURRENT TIMEZONE);

--
-- Delete the expired component records from the mart.
--
--#EXECUTE_AT_TARGET
delete from MM.COMP C WHERE C.COMP_ID IN (SELECT COMP_ID FROM MM.STAGE_EXPCOMP);

-- #################################### -- 

--#IGNORE_ERROR
--#EXECUTE_AT_TARGET
drop table MM.STAGE_ATTRTYP;

--#EXECUTE_AT_TARGET
CREATE TABLE MM.STAGE_ATTRTYP (
       ATTRTYP_CD           CHAR(17) NOT NULL,
       ATTRTYP_NM           VARCHAR(64) NOT NULL,
       ATTRTYP_NM_DEF       VARCHAR(120) NOT NULL
);

--#INSERT_INTO_TARGET
insert into MM.STAGE_ATTRTYP 
SELECT 
    TWG.ATTRTYP.ATTRTYP_CD AS ATTRTYP_CD,
    CONCAT('AttrTyp.AttrTyp_Nm.',RTRIM(TWG.ATTRTYP.ATTRTYP_CD)) AS ATTRTYP_NM,
    TWG.ATTRTYP.ATTRTYP_NM AS ATTRTYP_NM_DEF 
FROM 
    TWG.ATTRTYP;

--#EXECUTE_AT_TARGET
insert into MM.ATTRTYP 
SELECT 
    ATTRTYP_CD AS ATTRTYP_CD,
    ATTRTYP_NM AS ATTRTYP_NM,
    ATTRTYP_NM_DEF AS ATTRTYP_NM_DEF 
FROM 
    MM.STAGE_ATTRTYP
WHERE
    ATTRTYP_CD NOT IN (SELECT ATTRTYP_CD FROM MM.ATTRTYP);

-- #################################### -- 

--#INSERT_INTO_TARGET
insert into MM.COMPATTR 
SELECT 
    TWG.CUR_COMPATTR.COMPATTR_ID AS COMPATTR_ID,
    TWG.CUR_COMPATTR.COMP_ID AS COMP_ID,
    TWG.CUR_COMPATTR.ATTRTYP_CD AS ATTRTYP_CD,
    TWG.CUR_COMPATTR.COMPATTR_STRT_DTTM AS COMPATTR_STRT_DTTM,
    TWG.CUR_COMPATTR.COMPATTR_END_DTTM AS COMPATTR_END_DTTM,
    RTRIM(TWG.CUR_COMPATTR.COMPATTR_VAL) AS COMPATTR_VAL 
FROM 
    TWG.CUR_COMPATTR
WHERE
    TWG.CUR_COMPATTR.COMPATTR_ID > (SELECT EC.EXTCTL_TO_INTSEQ FROM TWG.EXTRACT_CONTROL EC WHERE
       EC.EXTCTL_SOURCE = 'TWG.CUR_COMPATTR' AND EC.EXTCTL_TARGET = 'DYK.COMPATTR');

--
-- Delete expired component attribute records from the mart.
--

--
-- Get the IDs of all component attributes that have expired
-- since the completion of the last ETL run.
--
--#EXECUTE_AT_TARGET
--#IGNORE_ERROR
drop table MM.STAGE_EXPCOMPATTR;

--#EXECUTE_AT_TARGET
CREATE TABLE MM.STAGE_EXPCOMPATTR (
   COMPATTR_ID         INTEGER      NOT NULL
);

--#INSERT_INTO_TARGET
insert into MM.STAGE_EXPCOMPATTR 
SELECT
    CA.COMPATTR_ID
FROM
    TWG.COMPATTR CA
WHERE
    CA.COMPATTR_END_DTTM BETWEEN (SELECT ETL_END_DTTM FROM DYK.STAGE_ETL_INFO) AND (CURRENT TIMESTAMP - CURRENT TIMEZONE);

--
-- Delete the expired component attribute records from the mart.
--
--#EXECUTE_AT_TARGET
delete from MM.COMPATTR CA WHERE CA.COMPATTR_ID IN (SELECT COMPATTR_ID FROM MM.STAGE_EXPCOMPATTR);


-- #################################### -- 

--#EXECUTE_AT_TARGET
delete from MM.ATTRRUL;

--#INSERT_INTO_TARGET
insert into MM.ATTRRUL 
SELECT 
    TWG.ATTRRUL.COMPTYP_CD AS COMPTYP_CD,
    TWG.ATTRRUL.ATTRTYP_CD AS ATTRTYP_CD,
    TWG.ATTRRUL.ATTRRUL_STRT_DTTM AS ATTRRUL_STRT_DTTM,
    TWG.ATTRRUL.ATTRRUL_END_DTTM AS ATTRRUL_END_DTTM,
    TWG.ATTRRUL.ATTRRUL_DOM_IND AS ATTRRUL_DOM_IND 
FROM 
    TWG.ATTRRUL;

-- #################################### -- 

--#EXECUTE_AT_TARGET
delete from MM.ATTRDOM;

--#INSERT_INTO_TARGET
insert into MM.ATTRDOM 
SELECT 
    TWG.ATTRDOM.ATTRDOM_ID AS ATTRDOM_ID,
    TWG.ATTRDOM.COMPTYP_CD AS COMPTYP_CD,
    TWG.ATTRDOM.ATTRTYP_CD AS ATTRTYP_CD,
    TWG.ATTRDOM.ATTRDOM_STRT_DTTM AS ATTRDOM_STRT_DTTM,
    TWG.ATTRDOM.ATTRDOM_END_DTTM AS ATTRDOM_END_DTTM,
    TWG.ATTRDOM.ATTRDOM_VAL AS ATTRDOM_VAL,
    TWG.ATTRDOM.ATTRDOM_DS AS ATTRDOM_DS 
FROM 
    TWG.ATTRDOM;

-- #################################### -- 

--#IGNORE_ERROR
--#EXECUTE_AT_TARGET
drop table MM.STAGE_RELNTYP;

--#EXECUTE_AT_TARGET
CREATE TABLE MM.STAGE_RELNTYP (
       RELNTYP_CD           CHAR(6) NOT NULL,
       RELNTYP_NM           VARCHAR(64) NOT NULL,
       RELNTYP_NM_DEF       VARCHAR(120) NOT NULL
);

--#INSERT_INTO_TARGET
insert into MM.STAGE_RELNTYP 
SELECT 
    TWG.RELNTYP.RELNTYP_CD AS RELNTYP_CD,
    CONCAT('RelnTyp.RelnTyp_Nm.',RTRIM(TWG.RELNTYP.RELNTYP_CD)) AS RELNTYP_NM,
    TWG.RELNTYP.RELNTYP_NM AS RELNTYP_NM_DEF
FROM 
    TWG.RELNTYP;

--#EXECUTE_AT_TARGET
insert into MM.RELNTYP 
SELECT 
    RELNTYP_CD AS RELNTYP_CD,
    RELNTYP_NM AS RELNTYP_NM,
    RELNTYP_NM_DEF AS RELNTYP_NM_DEF
FROM 
    MM.STAGE_RELNTYP
WHERE
    RELNTYP_CD NOT IN (SELECT RELNTYP_CD FROM MM.RELNTYP);

-- #################################### -- 

--#EXECUTE_AT_TARGET
delete from MM.RELNRUL;

--#INSERT_INTO_TARGET
insert into MM.RELNRUL 
SELECT 
    TWG.RELNRUL.COMPTYP_SOURCE_CD AS COMPTYP_SOURCE_CD,
    TWG.RELNRUL.COMPTYP_TARGET_CD AS COMPTYP_TARGET_CD,
    TWG.RELNRUL.RELNTYP_CD AS RELNTYP_CD,
    TWG.RELNRUL.RELNRUL_STRT_DTTM AS RELNRUL_STRT_DTTM,
    TWG.RELNRUL.RELNRUL_END_DTTM AS RELNRUL_END_DTTM
FROM 
    TWG.RELNRUL;

-- #################################### -- 

--#INSERT_INTO_TARGET
insert into MM.COMPRELN 
SELECT 
    TWG.CUR_COMPRELN.COMPRELN_ID AS COMPRELN_ID,
    TWG.CUR_COMPRELN.COMP_SOURCE_ID AS COMP_SOURCE_ID,
    TWG.CUR_COMPRELN.COMP_TARGET_ID AS COMP_TARGET_ID,
    TWG.CUR_COMPRELN.RELNTYP_CD AS RELNTYP_CD,
    TWG.CUR_COMPRELN.COMPRELN_STRT_DTTM AS COMPRELN_STRT_DTTM,
    TWG.CUR_COMPRELN.COMPRELN_END_DTTM AS COMPRELN_END_DTTM
FROM 
    TWG.CUR_COMPRELN
WHERE
    TWG.CUR_COMPRELN.COMPRELN_ID > (SELECT EC.EXTCTL_TO_INTSEQ FROM TWG.EXTRACT_CONTROL EC WHERE
       EC.EXTCTL_SOURCE = 'TWG.CUR_COMPRELN' AND EC.EXTCTL_TARGET = 'DYK.COMPRELN');

--
-- Delete expired component relationship records from the mart.
--

--
-- Get the IDs of all component relationships that have expired
-- since the completion of the last ETL run.
--
--#EXECUTE_AT_TARGET
--#IGNORE_ERROR
drop table MM.STAGE_EXPCOMPRELN;

--#EXECUTE_AT_TARGET
CREATE TABLE MM.STAGE_EXPCOMPRELN (
   COMPRELN_ID         INTEGER      NOT NULL
);

--#INSERT_INTO_TARGET
insert into MM.STAGE_EXPCOMPRELN 
SELECT
    CR.COMPRELN_ID
FROM
    TWG.COMPRELN CR
WHERE
    CR.COMPRELN_END_DTTM BETWEEN (SELECT ETL_END_DTTM FROM DYK.STAGE_ETL_INFO) AND (CURRENT TIMESTAMP - CURRENT TIMEZONE);

--
-- Delete the expired component relationship records from the mart.
--
--#EXECUTE_AT_TARGET
delete from MM.COMPRELN CR WHERE CR.COMPRELN_ID IN (SELECT COMPRELN_ID FROM MM.STAGE_EXPCOMPRELN);

-- #################################### -- 

--#EXECUTE_AT_TARGET
delete from MM.TRANSLATED_TERM;

--#INSERT_INTO_TARGET
insert into MM.TRANSLATED_TERM 
SELECT 
    TWG.TRANSLATED_TERM.TERM_ID AS TERM_ID,
    TWG.TRANSLATED_TERM.TERM_KEY AS TERM_KEY,
    TWG.TRANSLATED_TERM.TERM_LOCALE AS TERM_LOCALE,
    TWG.TRANSLATED_TERM.TERM_VALUE AS TERM_VALUE
FROM 
    TWG.TRANSLATED_TERM;

-- #################################### -- 
