------------------------ COPYRIGHT STATEMENT ----------------------------
--
-- Licensed Materials - Property of IBM
-- 5724-C40
-- (C) Copyright IBM Corp. 2003.  All Rights Reserved.
--
-- US Government Users Restricted Rights - Use, duplication or
-- disclosure restricted by GSA ADP Schedule Contract with
-- IBM Corp.
--
------------------------END OF COPYRIGHT STATEMENT -----------------------

--------------------------------------------------------------------------
--  CMVC Location:  src/tedw_apps/dyk/etl/sql/DYK_m10_s030_Populate_SLM_MMA_Msmts.db2, etl.target, slm1.2.1.fp1
--  Version:        1.1
--  Last Modified:  7/18/03
--------------------------------------------------------------------------

-- Insert total msmt data
--#INSERT_INTO_TARGET
insert into DYK.MSMT_MMA
    SELECT
        DYK.STAGE_MSMT.MSMT_ID AS MSMT_ID,
        DYK.STAGE_MSMT.MSMTTYP_ID AS MSMTTYP_ID,
        DYK.STAGE_MSMT.COMP_ID AS COMP_ID,
        DYK.STAGE_MSMT.COMP_NM AS COMP_NM,
        DYK.STAGE_MSMT.COMPTYP_CD AS COMPTYP_CD,
        DYK.STAGE_MSMT.TMSUM_CD AS TMSUM_CD,
        DYK.STAGE_MSMT.MSMT_ST AS MSMT_ST,
        DYK.STAGE_MSMT.MSMT_MIN_VAL AS MSMT_MIN_VAL,
        DYK.STAGE_MSMT.MSMT_MAX_VAL AS MSMT_MAX_VAL,
        DYK.STAGE_MSMT.MSMT_AVG_VAL AS MSMT_AVG_VAL,
        DYK.STAGE_MSMT.MSMT_SMPL_CNT AS MSMT_SMPL_CNT,
        DYK.STAGE_MSMT.MSMT_ERR_CNT AS MSMT_ERR_CNT,
        CURRENT TIMESTAMP - CURRENT TIMEZONE AS TM,
        0 AS LATE
    FROM
        DYK.STAGE_MSMT
    WHERE
        DYK.STAGE_MSMT.MGRP_CD = 'AVG_E'
;

-- Update datamart extract log
--#EXECUTE_AT_TARGET
insert into DYK.EXTRACT_LOG (COMPLETE_TM, START_RANGE, END_RANGE)
    SELECT
        CURRENT TIMESTAMP - CURRENT TIMEZONE as TM,
        COALESCE(MIN(DYK.STAGE_MSMT.MSMT_ID), (SELECT MAX(START_RANGE) FROM DYK.EXTRACT_LOG), 0) AS ST_RANGE,
        COALESCE(MAX(DYK.STAGE_MSMT.MSMT_ID), (SELECT MAX(END_RANGE) FROM DYK.EXTRACT_LOG), 0) AS END_RANGE
    FROM
        DYK.STAGE_MSMT;
