------------------------ COPYRIGHT STATEMENT ----------------------------
--
-- Licensed Materials - Property of IBM
-- 5724-C40
-- (C) Copyright IBM Corp. 2003.  All Rights Reserved.
--
-- US Government Users Restricted Rights - Use, duplication or
-- disclosure restricted by GSA ADP Schedule Contract with
-- IBM Corp.
--
------------------------END OF COPYRIGHT STATEMENT -----------------------

--------------------------------------------------------------------------
--  CMVC Location:  src/tedw_apps/dyk/etl/sql/DYK_m10_s040_Update_Extract_Control.db2, etl.target, slm1.2.1.fp1
--  Version:        1.1
--  Last Modified:  7/18/03
--------------------------------------------------------------------------

-- create temporary table for extract control update
--#IGNORE_ERROR
--#EXECUTE_AT_TARGET
drop table DYK.EXT_UPD;

--#EXECUTE_AT_TARGET
create table DYK.EXT_UPD (
    MSMT_ST     BIGINT NOT NULL,
    MSMT_END    BIGINT NOT NULL
);

-- insert values into temporary extract table
--#INSERT_INTO_TARGET
insert into DYK.EXT_UPD
    select
        DYK.EXTRACT_LOG.START_RANGE,
        DYK.EXTRACT_LOG.END_RANGE
    from
        DYK.EXTRACT_LOG
    where
        COMPLETE_TM = (select max(COMPLETE_TM) from DYK.EXTRACT_LOG);

-- Update TWH extract control
--#EXECUTE_AT_TARGET
update
    TWG.EXTRACT_CONTROL
set
    (extctl_to_intseq, extctl_from_intseq) = (select msmt_end, msmt_st from DYK.ext_upd)
where
    extctl_source = 'TWG.MSMT' and
    extctl_target = 'DYK.STAGE_MSMT';
    
--#IGNORE_ERROR
--#EXECUTE_AT_TARGET
drop table DYK.EXT_UPD;
